﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Collections;
using System.Diagnostics;

namespace CustomOrderInGroup
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            xamDataGrid1.DataSource = new List<Data>
            {
                new Data { ID = 3, Abbreviation = "z", Abbreviation1 = "a" },
                new Data { ID = 5, Abbreviation = "z", Abbreviation1 = "a" },
                new Data { ID = 3, Abbreviation = "a", Abbreviation1 = "b"  },
                new Data { ID = 2, Abbreviation = "a", Abbreviation1 = "b"  },
                new Data { ID = 3, Abbreviation = "a", Abbreviation1 = "c"  },
                new Data { ID = 6, Abbreviation = "a", Abbreviation1 = "c"  },
                new Data { ID = 1, Abbreviation = "b", Abbreviation1 = "d" },
                new Data { ID = 0, Abbreviation = "b", Abbreviation1 = "d" },
                new Data { ID = 5, Abbreviation = "3v", Abbreviation1 = "e" },
                new Data { ID = 10, Abbreviation = "3v", Abbreviation1 = "e" },
                new Data { ID = 2, Abbreviation = "c", Abbreviation1 = "f" },
                new Data { ID = -1, Abbreviation = "c", Abbreviation1 = "f" },
            };
            helper.sortingCol = "";
        }

        private void xamDataGrid1_Sorted(object sender, Infragistics.Windows.DataPresenter.Events.SortedEventArgs e)
        {
            // in case of numeric summary column sorting
            if (helper.summarySortAllowCols.IndexOf("|" + e.Field.Name + "|") > -1)
            {
                string strGrpSort = "";
                Hashtable htGrp = new Hashtable();
                int intgrpcount = 0;
                // get the group by colum(s). will be helpfull incase more than one group by selected
                for (int intcnt = 0; intcnt <= xamDataGrid1.FieldLayouts[0].SortedFields.Count - 1; intcnt++)
                {
                    if (xamDataGrid1.FieldLayouts[0].SortedFields[intcnt].IsGroupBy)
                    {
                        htGrp.Add(intgrpcount, xamDataGrid1.FieldLayouts[0].SortedFields[intcnt].FieldName);
                        intgrpcount++;

                    }
                }
                if (intgrpcount > 0)
                {
                    for (int intcnt = 0; intcnt <= htGrp.Count - 1; intcnt++)
                    {
                        e.FieldLayout.SortedFields.Add(new FieldSortDescription(htGrp[intcnt].ToString(), e.SortDescription.Direction, true));
                    }
                }
            }
            helper.sortingCol = e.Field.Name;
        }

        private void xamDataGrid1_Sorting(object sender, Infragistics.Windows.DataPresenter.Events.SortingEventArgs e)
        {

            Hashtable htGrp = new Hashtable();
            Hashtable htSortDirection = new Hashtable();
            int intgrpcount = 0;
            // get the group by colum(s).
            for (int intcnt = 0; intcnt <= xamDataGrid1.FieldLayouts[0].SortedFields.Count - 1; intcnt++)
            {
                if (xamDataGrid1.FieldLayouts[0].SortedFields[intcnt].IsGroupBy)
                {
                    htGrp.Add(intgrpcount, xamDataGrid1.FieldLayouts[0].SortedFields[intcnt].FieldName);
                    htSortDirection.Add(intgrpcount, xamDataGrid1.FieldLayouts[0].SortedFields[intcnt].Direction);
                    intgrpcount++;
                }
            }

            // clear the sorting column (as we are adding in xamDataGrid1_Sorting. remove unused sorting columns)
            e.FieldLayout.SortedFields.Clear();

            // add group by columns
            bool IsSortColExist = false;
            bool IsGrpSort = false;
            if (intgrpcount > 0)
            {
                IsGrpSort = true;
                for (int intcnt = 0; intcnt <= htGrp.Count - 1; intcnt++)
                {
                    e.FieldLayout.SortedFields.Add(new FieldSortDescription(htGrp[intcnt].ToString(), (System.ComponentModel.ListSortDirection)htSortDirection[intcnt], true));
                    if (e.Field.Name == htGrp[intcnt].ToString())
                        IsSortColExist = true;
                }
            }
            // if the sorting column is not group by column then add it
            if (IsSortColExist==false)
                e.FieldLayout.SortedFields.Add(new FieldSortDescription(e.Field.Name, e.SortDescription.Direction, IsGrpSort));

            helper.sortingCol = e.Field.Name;
        }
    }
    public class AbbreviationSortComparer : IComparer
    {
        public int Compare(object x, object y)
        {
            var gbX = x as GroupByRecord;
            var gbY = y as GroupByRecord;

            if (gbX == gbY)
                return 0;
            else if (gbX == null)
                return -1;
            else if (gbY == null)
                return 1;

            var summariesX = gbX.ChildRecords.SummaryResults;
            var summariesY = gbY.ChildRecords.SummaryResults;

            // sorting on summary column (in case group by selected and trying to sort on summary column)
            if (summariesX.Count != 0)
            {
                // (summariesX[0].SourceField.Name == helper.sortingCol) -> fired after xamDataGrid1_Sorted. if sorting column is the summary column
                // ((summariesX[0].SourceField.Name == gbX.GroupByField.Name) && (helper.summarySortAllowCols.IndexOf("|" +gbX.GroupByField.Name +"|")>-1)) -> if group by column is the summary column (ex: group by ID)
                if ((summariesX[0].SourceField.Name == helper.sortingCol) || ((summariesX[0].SourceField.Name == gbX.GroupByField.Name) && (helper.summarySortAllowCols.IndexOf("|" +gbX.GroupByField.Name +"|")>-1)))
                {
                    var result = Comparer.Default.Compare(summariesX[0].Value, summariesY[0].Value);

                    if (result != 0)
                        return result;
                }
            }

            return Comparer.Default.Compare(gbX.Value, gbY.Value);
        }
    }
    public class Data
    {
        public int ID { get; set; }
        public string Abbreviation { get; set; }
        public string Abbreviation1 { get; set; }
    }
    public class helper
    {
        public static string sortingCol = "";
        public static string summarySortAllowCols = "|ID|";
    }
}
